function [w, b, obj_val, pd_gap] = consensus_pdhg(X, y, lambda, max_iter, tol)
%CONSENSUS_PDHG Summary of this function goes here
%   Detailed explanation goes here

    [N, d] = size(X);

    
    pd_gap = zeros(1, max_iter);
    obj_val = zeros(1, max_iter);
    
    % setup linear operator
    K = ..;
    
    norm_K = normest(K);
    
    % compute stepsizes so that your algorithm converges.
    % This is very important. cf. lecture notes.
    tau = ..;
    sigma = ..;
    
    obj_handle = @(u) sum(max(0, ..)) + lambda*sum(abs(u(1:end-1)));
    for it=1:max_iter

        % Optional: you may compute the primal dual gap here, to see how
        % close you are to the global optimum.
        pd_gap(it) = ...
        obj_val(it) = obj_handle(u);
    end
    
    w = u(1:d);
    b = u(end);
end

